
#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <sys/time.h>

#include <MaxCompilerRT.h>

#define ARRAY_SIZE 2
#define STREAM_SIZE 16

//#define DATA_SIZE 49408
static void startClock(struct timeval *startTime, char **bufferStartTime);
static void stopClock(struct timeval *endTime, char **bufferEndTime);
static void printResult(struct timeval *startTime, struct timeval *endTime,
		char **bufferStartTime, char **bufferEndTime);


int main(int argc, char* argv[])
{

    struct timeval startTime;
	struct timeval endTime;
	char *bufferStartTime = malloc(sizeof(char) * 50);
	char *bufferEndTime = malloc(sizeof(char) * 50);

	struct timeval *s = &startTime;
	struct timeval *e = &endTime;
	// ==============================
	//time_t start = time(NULL);
	startClock(s, &bufferStartTime);


    char *device_name = (argc==2 ? argv[1] : NULL);


    printf("Allocate memory\n");
    FILE *fileMbState;
    FILE *fileMaxState;
    FILE *fileIter;
    FILE *fileOutput;

    FILE *filePara;

    printf("Allocate memory 2 \n");
    char dataMbState[256];
    char dataMaxState[256];
    char dataIter[256];
    char dataOutput[256];

    char dataPara[256];

    printf("Allocate memory 3 \n ");

    char filePathMbState[] = "mbState.txt";
    char filePathMaxState[] = "maxState.txt";
    char filePathIter[] = "iter.txt";
    char filePathOutput[] = "output.txt";

    char filePathPara[] = "para.txt";

    printf("Allocate memory 4\n");

    int32_t *out1;
    int32_t *out2;
    int32_t *mbState;
    int32_t *maxState;
    uint8_t *iter;

    int32_t *para;



    int i, k, p, l;

    int status = 0;

    printf("Opening and configuring FPGA.\n");

	max_maxfile_t* maxfile;
	max_device_handle_t* device;

	maxfile = max_maxfile_init_A2();
	device = max_open_device(maxfile, device_name);

    /*
    int32_t *milliseconds;
    milliseconds=0;
    void max_set_pcie_streams_timeout(max_device_handle_t* device_handle,int32_t milliseconds);
    */

    printf("Read from para.\n");


    filePara = fopen(filePathPara, "rt");

    para = malloc(3*sizeof(int32_t));

    //int m=0;
    //while (fgets(dataPara, 3, filePara) != NULL)
    for(int m=0; m<3; m++){
        fgets(dataPara, 256, filePara);
        sscanf(dataPara, "%d", &para[m]);
        //printf("%d\n", para[m]);
       // m++;

    }

    fclose(filePara);

    k = 0;
    int DATA_SIZE, K, cycles;

    DATA_SIZE = para[0];
    //antalet flerpartikeltillstånd
    K = para[1];
    // antal cykler
    cycles = para[2];

    printf("Data size %d\n", DATA_SIZE);
    printf("number of mbStates %d\n", K);
    printf("Number of cycles %d\n", cycles);


    printf("Generating data to send to FPGA.\n");



    // öppnar filePatheState och associerar denna till fileState
    fileMbState = fopen(filePathMbState, "rt");
    fileMaxState = fopen(filePathMaxState, "rt");
    fileIter = fopen(filePathIter, "rt");


    //allokerar minnesplats till datan som ska skickas till FPGAn
    mbState =  malloc(K*2* sizeof(int32_t));
    maxState =  malloc(K*2* sizeof(int32_t));
    iter =  malloc(cycles * sizeof(uint8_t));

    // To send the arrays to the FPGA we pack them together
    //in_array = malloc(ARRAY_SIZE * STREAM_SIZE * sizeof(uint32_t));
    out1 = malloc(4 * cycles * sizeof(uint32_t));
    out2 = malloc(4 * cycles * sizeof(uint32_t));


    // Läser in rad för rad från filen fileStates till dataStates
    while (fgets(dataMbState, DATA_SIZE, fileMbState) != NULL) {
        fgets(dataMaxState, DATA_SIZE, fileMaxState);
        //fgets(dataIter, 256, fileIter);

        //fgets(dataIter, 2, fileIter);
        //sscanf(dataIter, "%d", &iter[k]);
        //printf(dataMbState);

        //printf("%d\n", iter[k]);

        sscanf(dataMbState, "%d", &mbState[k]);
        sscanf(dataMaxState, "%d", &maxState[k]);
        //printf("%d\n", mbState[k]);

        // plockar ut nästa rad
        k++;
    }
    printf("k=%d\n", k);

    l=0;
    /*
    //läser in iter - annan längd
    while (fgets(dataIter, 256, fileIter) != NULL) {
        sscanf(dataIter, "%d", &iter[l]);
        // plockar ut nästa rad
        l++;
    }
    */
    while (fgets(dataIter, DATA_SIZE, fileIter)!= NULL)
    //for(int i=0 ; i<16 ; i++)
    {
        sscanf(dataIter, "%d", &iter[l]);
        //printf(dataIter);
        //printf("%d\n", iter[l]);
        l++;
	}




    printf("l=%d\n", l);


    /*
    char oss[256];
    oss <= k;

    printf(oss);
     */
    //max_set_scalar_input(device, "ArraysKernel.P1", P1, FPGA_A);
    printf("\nTime before FPGA:\n");
	stopClock(e, &bufferEndTime);
	printResult(s, e, &bufferStartTime, &bufferEndTime);
	startClock(s, &bufferStartTime);


    printf("Streaming data to/from FPGA.\n");
    for(int i =0; i < 1000; i++){
    max_run(device,
            max_input("mbState", mbState, (k)  * sizeof(int32_t)),
            max_input("maxState", maxState, (k)  * sizeof(int32_t)),
            max_input("iter", iter, cycles * sizeof(uint8_t)),
            max_output("out1",out1 ,cycles * 4 * sizeof(uint32_t)),
            max_output("out2",out2 ,cycles * 4 * sizeof(uint32_t)),
            max_runfor("A2Kernel",cycles),max_end());
	}
	printf("\nTime for FPGA (*1000):\n");
	stopClock(e, &bufferEndTime);
	printResult(s, e, &bufferStartTime, &bufferEndTime);
	startClock(s, &bufferStartTime);

    // max_output("out2",out2 ,dd * 4 * sizeof(uint32_t))

    // här ska göras samma för andra outputten

    // öppnar output-filen
    fileOutput = fopen(filePathOutput, "wr");

    printf("Write to file.\n");
    int q1=0;
    int q2=0;
    for (p = 0; p < cycles; p++) {


        for (int d=0; d<4; d++) {
            if(out1[q1-d]!=-1){
            sprintf(dataOutput, "%d\t", out1[q1]);
            fputs(dataOutput, fileOutput);
            }
            q1++;
        }

        for (int d=0; d<4; d++) {
              if(out2[q2-d]!=-1){
            sprintf(dataOutput, "%d\t", out2[q2]);
            fputs(dataOutput, fileOutput);
            }
            q2++;
        }
        sprintf(dataOutput,"\n");
        fputs(dataOutput, fileOutput);


        //printf("%d\n", out1[p]);
        //printf("%d\n", out2[p]);

       // sprintf(dataOutput, "%d\n", out1[p]);


        //sprintf(dataOutput, "%d\n", out2[p]);
        //fputs(dataOutput, fileOutput);

    }

    fclose(fileMbState);
    fclose(fileMaxState);
    fclose(fileIter);
    fclose(fileOutput);



    printf("Shutting down\n");
    max_close_device(device);
    max_destroy(maxfile);

    printf("\nTime after FPGA:\n");
	stopClock(e, &bufferEndTime);
	printResult(s, e, &bufferStartTime, &bufferEndTime);

    return status;
}

static void startClock(struct timeval *startTime, char **bufferStartTime) {
	gettimeofday(startTime, 0);
	time_t startTimeT = startTime->tv_sec;
	struct tm *startDateTm = localtime(&startTimeT);
	strftime(*bufferStartTime, sizeof(char) * 50, "%a %b %Y %H:%M:%S",
			startDateTm);
}

static void stopClock(struct timeval *endTime, char **bufferEndTime) {
	gettimeofday(endTime, 0);
	time_t endTimeT = endTime->tv_sec;
	struct tm *endDateTm = localtime(&endTimeT);
	strftime(*bufferEndTime, sizeof(char) * 50, "%a %b %Y %H:%M:%S",
			endDateTm);
}

static void printResult(struct timeval *startTime, struct timeval *endTime,
		char **bufferStartTime, char **bufferEndTime) {
	double runTime;

	if (endTime->tv_usec - startTime->tv_usec < 0) {
		runTime = (((endTime->tv_sec - startTime->tv_sec) * 1000000 +
				((1000000 - startTime->tv_usec) + endTime->tv_usec)) *
				0.000001) - 1;
	} else {
		runTime = ((endTime->tv_sec - startTime->tv_sec) * 1000000 +
				(endTime->tv_usec - startTime->tv_usec)) * 0.000001;
	}

	//printf("\nProgram started executing at %s\n", *bufferStartTime);
	//printf("Program finished executing at %s\n", *bufferEndTime);
	printf("Total runtime (in seconds): %f\n \n", runTime);
}
