
package OnebodyOp.A2;

import com.maxeler.maxcompiler.v1.kernelcompiler.Kernel;
import com.maxeler.maxcompiler.v1.kernelcompiler.KernelParameters;
import com.maxeler.maxcompiler.v1.kernelcompiler.stdlib.Bitops;
import com.maxeler.maxcompiler.v1.kernelcompiler.stdlib.core.Count;
import com.maxeler.maxcompiler.v1.kernelcompiler.types.base.HWVar;
import com.maxeler.maxcompiler.v1.kernelcompiler.types.composite.KArray;
import com.maxeler.maxcompiler.v1.kernelcompiler.types.composite.KArrayType;

public class A2Kernel extends Kernel
{
	//private static final int width = 32;

	//public KArrayType<HWVar> array_type;
	//private final int k=2;
	private final int width=32;

	private final int a=7;
	private final int b=11;
	private final int c=13;

	public KArrayType<HWVar> array_type = new KArrayType<HWVar>(hwInt(32), 2);
	public KArrayType<HWVar> array_type1 = new KArrayType<HWVar>(hwInt(32), 4);



	public A2Kernel(KernelParameters parameters)
	{
		super(parameters);

		HWVar MaxDeg=io.input("iter", hwUInt(8));
		HWVar NextMaxDeg=stream.offset(MaxDeg,1);

		Count.Params params1 = control.count.makeParams(width).withReset(MaxDeg.cast(hwUInt(1)));
		// withMax

		Count.Counter c1=control.count.makeCounter(params1);

		// skapar räknare som håller koll på nuvarande tillstånd

		 Count.Params params2 = control.count.makeParams(width)
		.withEnable(NextMaxDeg.cast(hwUInt(1)).eq(1));

        Count.Counter currentStateCount = control.count.makeCounter(params2);


		//array_type=new KArrayType<HWVar>(hwInt(32), 2);
        //Inputs
		HWVar BI=c1.getCount().eq(0);


		KArray<HWVar> mbState= io.input("mbState", array_type,BI);
		KArray<HWVar> maxState = io.input("maxState", array_type,BI);
		//Outputs
		KArray<HWVar> out1 = array_type1.newInstance(this);
		KArray<HWVar> out2 = array_type1.newInstance(this);




        // partikel 1

        	HWVar newState1=c1.getCount().cast(hwInt(32))+mbState[0];

			HWVar change1 = constant.var(hwInt(32), -1);
			for(int u=0;u<2;u++)
			{

				change1 = newState1.eq(mbState[u])?u:change1;
			}
			change1 = (change1>-1)&(newState1.eq(mbState[0]))?-1:change1;

            // hittat koppling B0_1=true
			HWVar BO_1 = (change1<0)&(newState1<(1+maxState[0])) ;

			HWVar p1_1 =(newState1<mbState[1])?newState1:mbState[1];
			HWVar p2_1 =(newState1>mbState[1])?newState1:mbState[1];

			HWVar key0_1=Bitops.concat(p1_1,p2_1);

		HWVar key1_1=key0_1^(key0_1>>a);

		HWVar key2_1=key1_1^(key1_1<<b);

		HWVar key3_1 = key2_1^(key2_1>>c);

		HWVar key_1 = key2_1.slice(0,32);

		HWVar addr1=key3_1.slice(0,32)^key3_1.slice(31,32);

		HWVar sign_1 = (newState1<mbState[1])?constant.var(hwInt(32),0):constant.var(hwInt(32),1);



		out1[0]<==BO_1?addr1.cast(hwInt(32)):-1;
		out1[1]<==BO_1?sign_1:-1;
		out1[2]<==BO_1?key_1.cast(hwInt(32)):-1;
		out1[3]<==currentStateCount.getCount().cast(hwInt(32));

		io.output("out1",out1,array_type1);



		// partikel 2

        	HWVar newState2=c1.getCount().cast(hwInt(32))+mbState[1];

			HWVar change2 = constant.var(hwInt(32), -1);
			for(int u=0;u<2;u++)
			{

				change2 = newState2.eq(mbState[u])?u:change2;
			}
			change2 = (change2>-1)&(newState2.eq(mbState[1]))?-1:change2;

            // hittat koppling B0_2=true
			HWVar BO_2 = (change2<0)&(newState2<(1+maxState[1])) ;

			HWVar p1_2 =(newState2<mbState[0])?newState2:mbState[0];
			HWVar p2_2 =(newState2>mbState[0])?newState2:mbState[0];

			HWVar key0_2=Bitops.concat(p1_2,p2_2);

		HWVar key1_2=key0_2^(key0_2>>a);

		HWVar key2_2=key1_2^(key1_2<<b);

		HWVar key3_2=key2_2^(key2_2>>c);

		HWVar key_2 = key2_2.slice(0,32);

		HWVar addr2=key3_2.slice(0,32)^key3_2.slice(31,32);

		HWVar sign_2 = (newState1>mbState[0])?constant.var(hwInt(32),0):constant.var(hwInt(32),1);



		out2[0]<==BO_2?addr2.cast(hwInt(32)):-1;
		out2[1]<==BO_2?sign_2:-1;
		out2[2]<==BO_2?key_2.cast(hwInt(32)):-1;
		out2[3]<==currentStateCount.getCount().cast(hwInt(32));

		io.output("out2",out2,array_type1);


		//out2[0]<==BO_2?constant.var(hwInt(32), 0):-1;



	}

}
