
package OnebodyOp.A4;

import com.maxeler.maxcompiler.v1.kernelcompiler.Kernel;
import com.maxeler.maxcompiler.v1.kernelcompiler.KernelParameters;
import com.maxeler.maxcompiler.v1.kernelcompiler.stdlib.Bitops;
import com.maxeler.maxcompiler.v1.kernelcompiler.stdlib.core.Count;
import com.maxeler.maxcompiler.v1.kernelcompiler.types.base.HWVar;
import com.maxeler.maxcompiler.v1.kernelcompiler.types.composite.KArray;
import com.maxeler.maxcompiler.v1.kernelcompiler.types.composite.KArrayType;

public class A4Kernel extends Kernel
{
	//private static final int width = 32;

	//public KArrayType<HWVar> array_type;
	//private final int k=2;
	private final int width=32;
	
	private final int a=7;
	private final int b=11;
	private final int c=13;
	
	public KArrayType<HWVar> array_type = new KArrayType<HWVar>(hwInt(32), 4);
	public KArrayType<HWVar> array_type1 = new KArrayType<HWVar>(hwInt(32), 4);



	public A4Kernel(KernelParameters parameters)
	{
		super(parameters);

		HWVar MaxDeg=io.input("iter", hwUInt(8));
		HWVar NextMaxDeg=stream.offset(MaxDeg,1);

		Count.Params params1 = control.count.makeParams(width).withReset(MaxDeg.cast(hwUInt(1)));
		// withMax

		Count.Counter c1=control.count.makeCounter(params1);

		// skapar räknare som håller koll på nuvarande tillstånd

		Count.Params params2 = control.count.makeParams(width)
		.withEnable(NextMaxDeg.cast(hwUInt(1)).eq(1));

		Count.Counter currentStateCount = control.count.makeCounter(params2);


		//array_type=new KArrayType<HWVar>(hwInt(32), 2);
		//Inputs
		HWVar BI=c1.getCount().eq(0);


		KArray<HWVar> mbState= io.input("mbState", array_type,BI);
		KArray<HWVar> maxState = io.input("maxState", array_type,BI);
		//Outputs
		KArray<HWVar> out1 = array_type1.newInstance(this);
		KArray<HWVar> out2 = array_type1.newInstance(this);
		KArray<HWVar> out3 = array_type1.newInstance(this);
		KArray<HWVar> out4 = array_type1.newInstance(this);



		// partikel 1 =========================================================

		HWVar newState1=c1.getCount().cast(hwInt(32))+mbState[0];

		HWVar change1 = constant.var(hwInt(32), -1);
		for(int u=0;u<4;u++)
		{

			change1 = newState1.eq(mbState[u])?u:change1;
		}
		change1 = (change1>-1)&(newState1.eq(mbState[0]))?-1:change1;

		// hittat koppling B0_1=true
		HWVar BO_1 = (change1<0)&(newState1<(1+maxState[0])) ;



		HWVar p1_1=(newState1<mbState[1])?newState1:mbState[1];
		HWVar p2_1=(newState1<mbState[2])?((newState1<mbState[1])?mbState[1]:newState1):mbState[2];
		HWVar p3_1=(newState1<mbState[3])?((newState1<mbState[2])?mbState[2]:newState1):mbState[3];
		HWVar p4_1=(newState1>mbState[3])?newState1:mbState[3];

		HWVar key0_1=Bitops.concat(p1_1,p2_1,p3_1,p4_1);

		HWVar key1_1=key0_1^(key0_1>>a);

		HWVar key2_1=key1_1^(key1_1<<b);

		HWVar key3_1=key2_1^(key2_1>>c);

		HWVar key_1=key2_1.slice(0,32);

		HWVar addr1=key3_1.slice(0,32)^(key3_1.slice(32,32)^(key3_1.slice(64,32)^(key3_1.slice(96,32))));

		HWVar sign_1=(newState1.eq(p1_1))?constant.var(hwInt(32),0):((newState1.eq(p2_1))?constant.var(hwInt(32),1):((newState1.eq(p3_1))?constant.var(hwInt(32),2):constant.var(hwInt(32),3)));


		out1[0]<==BO_1?addr1.cast(hwInt(32)):-1;
		out1[1]<==BO_1?sign_1:-1; 
		//out1[1]<==BO_1?mbState[1].cast(hwInt(32)):-1;
		out1[2]<==BO_1?key_1.cast(hwInt(32)):-1;
		out1[3]<==currentStateCount.getCount().cast(hwInt(32));


		// out1[3]<==BO_1?currentStateCount.getCount().cast(hwInt(32)):-1;

		io.output("out1",out1,array_type1);



		// partikel 2 =========================================================

		HWVar newState2=c1.getCount().cast(hwInt(32))+mbState[1];

		HWVar change2 = constant.var(hwInt(32), -1);
		for(int u=0;u<4;u++)
		{

			change2 = newState2.eq(mbState[u])?u:change2;
		}
		change2 = (change2>-1)&(newState2.eq(mbState[1]))?-1:change2;

		// hittat koppling B0_2=true
		HWVar BO_2 = (change2<0)&(newState2<(1+maxState[1])) ;


		HWVar p1_2=(newState2<mbState[0])?newState2:mbState[0];
		HWVar p2_2=(newState2<mbState[2])?((newState2<mbState[0])?mbState[0]:newState2):mbState[2];
		HWVar p3_2=(newState2<mbState[3])?((newState2<mbState[2])?mbState[2]:newState2):mbState[3];
		HWVar p4_2=(newState2>mbState[3])?newState2:mbState[3];

		HWVar key0_2=Bitops.concat(p1_2,p2_2,p3_2,p4_2);

		HWVar key1_2=key0_2^(key0_2>>a);

		HWVar key2_2=key1_2^(key1_2<<b);

		HWVar key3_2=key2_2^(key2_2>>c);

		HWVar key_2=key2_2.slice(0,32);

		HWVar addr2=key3_2.slice(0,32)^(key3_2.slice(32,32)^(key3_2.slice(64,32)^(key3_2.slice(96,32))));
		
		HWVar sign_2=(newState2.eq(p1_2))?constant.var(hwInt(32),0):((newState2.eq(p2_2))?constant.var(hwInt(32),1):((newState2.eq(p3_2))?constant.var(hwInt(32),2):constant.var(hwInt(32),3)));
		
		sign_2 = sign_2 + 1;

		out2[0]<==BO_2?addr2.cast(hwInt(32)):-1;
		out2[1]<==BO_2?sign_2:-1; 
		//out1[1]<==BO_2?mbState[1].cast(hwInt(32)):-1;
		out2[2]<==BO_2?key_2.cast(hwInt(32)):-1;
		out2[3]<==currentStateCount.getCount().cast(hwInt(32));

		io.output("out2",out2,array_type1);


		//out2[0]<==BO_2?constant.var(hwInt(32), 0):-1;


		// partikel 3 =========================================================

		HWVar newState3=c1.getCount().cast(hwInt(32))+mbState[2];

		HWVar change3 = constant.var(hwInt(32), -1);
		for(int u=0;u<4;u++)
		{

			change3 = newState3.eq(mbState[u])?u:change3;
		}
		change3 = (change3>-1)&(newState3.eq(mbState[2]))?-1:change3;

		// hittat koppling B0_1=true
		HWVar BO_3 = (change3<0)&(newState3<(1+maxState[2])) ;


		HWVar p1_3=(newState3<mbState[0])?newState3:mbState[0];
		HWVar p2_3=(newState3<mbState[1])?((newState3<mbState[0])?mbState[0]:newState3):mbState[1];
		HWVar p3_3=(newState3<mbState[3])?((newState3<mbState[1])?mbState[1]:newState3):mbState[3];
		HWVar p4_3=(newState3>mbState[3])?newState3:mbState[3];

		HWVar key0_3=Bitops.concat(p1_3,p2_3,p3_3,p4_3);

		HWVar key1_3=key0_3^(key0_3>>a);

		HWVar key2_3=key1_3^(key1_3<<b);

		HWVar key3_3=key2_3^(key2_3>>c);

		HWVar key_3=key2_3.slice(0,32);

		HWVar addr3=key3_3.slice(0,32)^(key3_3.slice(32,32)^(key3_3.slice(64,32)^(key3_3.slice(96,32))));
		
		HWVar sign_3=(newState3.eq(p1_3))?constant.var(hwInt(32),0):((newState3.eq(p2_3))?constant.var(hwInt(32),1):((newState3.eq(p3_3))?constant.var(hwInt(32),2):constant.var(hwInt(32),3)));


		out3[0]<==BO_3?addr3.cast(hwInt(32)):-1;
		out3[1]<==BO_3?sign_3:-1; 
		//out1[1]<==BO_3?mbState[1].cast(hwInt(32)):-1;
		out3[2]<==BO_3?key_3.cast(hwInt(32)):-1;
		out3[3]<==currentStateCount.getCount().cast(hwInt(32));


		io.output("out3",out3,array_type1);

		// partikel 4 =========================================================

		HWVar newState4=c1.getCount().cast(hwInt(32))+mbState[3];

		HWVar change4 = constant.var(hwInt(32), -1);
		for(int u=0;u<4;u++)
		{

			change4 = newState4.eq(mbState[u])?u:change4;
		}
		change4 = (change4>-1)&(newState4.eq(mbState[3]))?-1:change4;

		// hittat koppling B0_1=true
		HWVar BO_4 = (change4<0)&(newState4<(1+maxState[3])) ;


		HWVar p1_4=(newState4<mbState[0])?newState4:mbState[0];
		HWVar p2_4=(newState4<mbState[1])?((newState4<mbState[0])?mbState[0]:newState4):mbState[1];
		HWVar p3_4=(newState4<mbState[2])?((newState4<mbState[1])?mbState[1]:newState4):mbState[2];
		HWVar p4_4=(newState4>mbState[2])?newState4:mbState[2];

		HWVar key0_4=Bitops.concat(p1_4,p2_4,p3_4,p4_4);

		HWVar key1_4=key0_4^(key0_4>>a);

		HWVar key2_4=key1_4^(key1_4<<b);

		HWVar key3_4=key2_4^(key2_4>>c);

		HWVar key_4=key2_4.slice(0,32);

		HWVar addr4=key3_4.slice(0,32)^(key3_4.slice(32,32)^(key3_4.slice(64,32)^(key3_4.slice(96,32))));

		HWVar sign_4=(newState4.eq(p1_4))?constant.var(hwInt(32),0):((newState4.eq(p2_4))?constant.var(hwInt(32),1):((newState4.eq(p3_4))?constant.var(hwInt(32),2):constant.var(hwInt(32),3)));


		out4[0]<==BO_4?addr4.cast(hwInt(32)):-1;
		out4[1]<==BO_4?sign_4:-1; 
		//out1[1]<==BO_4?mbState[1].cast(hwInt(32)):-1;
		out4[2]<==BO_4?key_4.cast(hwInt(32)):-1;
		out4[3]<==currentStateCount.getCount().cast(hwInt(32));

		io.output("out4",out4,array_type1);












	}

}