
package OnebodyOp.A8;

import com.maxeler.maxcompiler.v1.kernelcompiler.Kernel;
import com.maxeler.maxcompiler.v1.kernelcompiler.KernelParameters;
import com.maxeler.maxcompiler.v1.kernelcompiler.stdlib.Bitops;
import com.maxeler.maxcompiler.v1.kernelcompiler.stdlib.core.Count;
import com.maxeler.maxcompiler.v1.kernelcompiler.types.base.HWVar;
import com.maxeler.maxcompiler.v1.kernelcompiler.types.composite.KArray;
import com.maxeler.maxcompiler.v1.kernelcompiler.types.composite.KArrayType;

public class A8Kernel extends Kernel
{
	private final int width=32;
	
	private final int a=7;
	private final int b=11;
	private final int c=13;
	
	public KArrayType<HWVar> array_type = new KArrayType<HWVar>(hwInt(32), 8);
	public KArrayType<HWVar> array_type1 = new KArrayType<HWVar>(hwInt(32), 4);



	public A8Kernel(KernelParameters parameters)
	{
		super(parameters);

	    HWVar MaxDeg=io.input("iter", hwUInt(8));
		HWVar NextMaxDeg=stream.offset(MaxDeg,1);
		
		// Creates a counter that resets if maxDeg is 1.

		Count.Params params1 = control.count.makeParams(width)
				.withReset(MaxDeg.cast(hwUInt(1)));

		Count.Counter c1=control.count.makeCounter(params1);
		

		// Creates a counter to keep track of the current state
		// Increase by one if next value in MaxDeg is 1.

		 Count.Params params2 = control.count.makeParams(width)
				 .withEnable(NextMaxDeg.cast(hwUInt(1)).eq(1));
		 
        Count.Counter currentStateCount = control.count.makeCounter(params2);

        
        //Inputs
		HWVar BI=c1.getCount().eq(0);
		

		KArray<HWVar> mbState= io.input("mbState", array_type,BI);
		KArray<HWVar> maxState = io.input("maxState", array_type,BI);
		//Outputs
		KArray<HWVar> out1 = array_type1.newInstance(this);
		KArray<HWVar> out2 = array_type1.newInstance(this);
	    KArray<HWVar> out3 = array_type1.newInstance(this);
		KArray<HWVar> out4 = array_type1.newInstance(this);
		KArray<HWVar> out5 = array_type1.newInstance(this);
		KArray<HWVar> out6 = array_type1.newInstance(this);
		KArray<HWVar> out7 = array_type1.newInstance(this);
		KArray<HWVar> out8 = array_type1.newInstance(this);
		

 // partikel 1 ====================================================

        	HWVar newState1=c1.getCount().cast(hwInt(32))+mbState[0];

			HWVar change1 = constant.var(hwInt(32), -1);
			for(int u=0;u<8;u++)
			{

				change1 = newState1.eq(mbState[u])?u:change1;
			}
			change1 = (change1>-1)&(newState1.eq(mbState[0]))?-1:change1;

            // Checks to see if an connection is found.
			HWVar BO_1 = (change1<0)&(newState1<(1+maxState[0])) ;
			
			
		HWVar p1_1=(newState1<mbState[1])?newState1:mbState[1];
		HWVar p2_1=(newState1<mbState[2])?((newState1<mbState[1])?mbState[1]:newState1):mbState[2];
		HWVar p3_1=(newState1<mbState[3])?((newState1<mbState[2])?mbState[2]:newState1):mbState[3];
		HWVar p4_1=(newState1<mbState[4])?((newState1<mbState[3])?mbState[3]:newState1):mbState[4];
		HWVar p5_1=(newState1<mbState[5])?((newState1<mbState[4])?mbState[4]:newState1):mbState[5];
		HWVar p6_1=(newState1<mbState[6])?((newState1<mbState[5])?mbState[5]:newState1):mbState[6];
		HWVar p7_1=(newState1<mbState[7])?((newState1<mbState[6])?mbState[6]:newState1):mbState[7];
		HWVar p8_1=(newState1>mbState[7])?newState1:mbState[7];

		
		// Generates th Hash key and adress.
		
		HWVar key0_1=Bitops.concat(p1_1,p2_1,p3_1,p4_1,p5_1,p6_1,p7_1,p8_1);
		HWVar key1_1=key0_1^(key0_1>>a);
		HWVar key2_1=key1_1^(key1_1<<b);
		HWVar key3_1=key2_1^(key2_1>>c);
		HWVar key_1=key2_1.slice(0,32);

		HWVar addr1=key3_1.slice(0,32)^(key3_1.slice(32,32)^(key3_1.slice(64,32)^(key3_1.slice(96,32)^(key3_1.slice(128,32)^(key3_1.slice(160,32)^(key3_1.slice(192,32)^(key3_1.slice(224,32))))))));
			
		HWVar sign_1=(newState1.eq(p1_1))?constant.var(hwInt(32),0):((newState1.eq(p2_1))?constant.var(hwInt(32),1):((newState1.eq(p3_1))?constant.var(hwInt(32),2):((newState1.eq(p4_1))?constant.var(hwInt(32),3):((newState1.eq(p5_1))?constant.var(hwInt(32),4):((newState1.eq(p6_1))?constant.var(hwInt(32),5):((newState1.eq(p7_1))?constant.var(hwInt(32),6):constant.var(hwInt(32),7)))))));
		
		// Sends out the adress, the key, the sign and the current state.

		out1[0]<==BO_1?addr1.cast(hwInt(32)):-1; 
		out1[1]<==BO_1?sign_1:-1; 
		out1[2]<==BO_1?key_1.cast(hwInt(32)):-1;
		out1[3]<==currentStateCount.getCount().cast(hwInt(32));
		
		io.output("out1",out1,array_type1);
		
// partikel 2 ======================================================================
		

        	HWVar newState2=c1.getCount().cast(hwInt(32))+mbState[1];

			HWVar change2 = constant.var(hwInt(32), -1);
			for(int u=0;u<8;u++)
			{

				change2 = newState2.eq(mbState[u])?u:change2;
			}
			change2 = (change2>-1)&(newState2.eq(mbState[1]))?-1:change2;

			HWVar BO_2 = (change2<0)&(newState2<(1+maxState[1])) ;
			
			
		HWVar p1_2=(newState2<mbState[0])?newState2:mbState[0];
		HWVar p2_2=(newState2<mbState[2])?((newState2<mbState[0])?mbState[0]:newState2):mbState[2];
		HWVar p3_2=(newState2<mbState[3])?((newState2<mbState[2])?mbState[2]:newState2):mbState[3];
		HWVar p4_2=(newState2<mbState[4])?((newState2<mbState[3])?mbState[3]:newState2):mbState[4];
		HWVar p5_2=(newState2<mbState[5])?((newState2<mbState[4])?mbState[4]:newState2):mbState[5];
		HWVar p6_2=(newState2<mbState[6])?((newState2<mbState[5])?mbState[5]:newState2):mbState[6];
		HWVar p7_2=(newState2<mbState[7])?((newState2<mbState[6])?mbState[6]:newState2):mbState[7];
		HWVar p8_2=(newState2>mbState[7])?newState2:mbState[7];

		HWVar key0_2=Bitops.concat(p1_2,p2_2,p3_2,p4_2,p5_2,p6_2,p7_2,p8_2);

		HWVar key1_2=key0_2^(key0_2>>a);

		HWVar key2_2=key1_2^(key1_2<<b);

		HWVar key3_2=key2_2^(key2_2>>c);

		HWVar key_2=key2_2.slice(0,32);

		HWVar addr2=key3_2.slice(0,32)^(key3_2.slice(32,32)^(key3_2.slice(64,32)^(key3_2.slice(96,32)^(key3_2.slice(128,32)^(key3_2.slice(160,32)^(key3_2.slice(192,32)^(key3_2.slice(224,32))))))));
				
		HWVar sign_2=(newState2.eq(p1_2))?constant.var(hwInt(32),0):((newState2.eq(p2_2))?constant.var(hwInt(32),1):((newState2.eq(p3_2))?constant.var(hwInt(32),2):((newState2.eq(p4_2))?constant.var(hwInt(32),3):((newState2.eq(p5_2))?constant.var(hwInt(32),4):((newState2.eq(p6_2))?constant.var(hwInt(32),5):((newState2.eq(p7_2))?constant.var(hwInt(32),6):constant.var(hwInt(32),7)))))));
		
		sign_2 = sign_2 + 1;
		
		out2[0]<==BO_2?addr2.cast(hwInt(32)):-1;
		out2[1]<==BO_2?sign_2:-1;
		out2[2]<==BO_2?key_2.cast(hwInt(32)):-1;
		out2[3]<==currentStateCount.getCount().cast(hwInt(32));
		
		io.output("out2",out2,array_type1);
		
// partikel 3 =========================================================

        	HWVar newState3=c1.getCount().cast(hwInt(32))+mbState[2];

			HWVar change3 = constant.var(hwInt(32), -1);
			for(int u=0;u<8;u++)
			{

				change3 = newState3.eq(mbState[u])?u:change3;
			}
			change3 = (change3>-1)&(newState3.eq(mbState[2]))?-1:change3;

			HWVar BO_3 = (change3<0)&(newState3<(1+maxState[2])) ;
			
		HWVar p1_3=(newState3<mbState[0])?newState3:mbState[0];
		HWVar p2_3=(newState3<mbState[1])?((newState3<mbState[0])?mbState[0]:newState3):mbState[1];
		HWVar p3_3=(newState3<mbState[3])?((newState3<mbState[1])?mbState[1]:newState3):mbState[3];
		HWVar p4_3=(newState3<mbState[4])?((newState3<mbState[3])?mbState[3]:newState3):mbState[4];
		HWVar p5_3=(newState3<mbState[5])?((newState3<mbState[4])?mbState[4]:newState3):mbState[5];
		HWVar p6_3=(newState3<mbState[6])?((newState3<mbState[5])?mbState[5]:newState3):mbState[6];
		HWVar p7_3=(newState3<mbState[7])?((newState3<mbState[6])?mbState[6]:newState3):mbState[7];
		HWVar p8_3=(newState3>mbState[7])?newState3:mbState[7];

		HWVar key0_3=Bitops.concat(p1_3,p2_3,p3_3,p4_3,p5_3,p6_3,p7_3,p8_3);

		HWVar key1_3=key0_3^(key0_3>>a);

		HWVar key2_3=key1_3^(key1_3<<b);

		HWVar key3_3=key2_3^(key2_3>>c);

		HWVar key_3=key2_3.slice(0,32);

		HWVar addr3=key3_3.slice(0,32)^(key3_3.slice(32,32)^(key3_3.slice(64,32)^(key3_3.slice(96,32)^(key3_3.slice(128,32)^(key3_3.slice(160,32)^(key3_3.slice(192,32)^(key3_3.slice(224,32))))))));
		
		HWVar sign_3=(newState3.eq(p1_3))?constant.var(hwInt(32),0):((newState3.eq(p2_3))?constant.var(hwInt(32),1):((newState3.eq(p3_3))?constant.var(hwInt(32),2):((newState3.eq(p4_3))?constant.var(hwInt(32),3):((newState3.eq(p5_3))?constant.var(hwInt(32),4):((newState3.eq(p6_3))?constant.var(hwInt(32),5):((newState3.eq(p7_3))?constant.var(hwInt(32),6):constant.var(hwInt(32),7)))))));
		

		out3[0]<==BO_3?addr3.cast(hwInt(32)):-1;
		out3[1]<==BO_3?sign_3:-1;
		out3[2]<==BO_3?key_3.cast(hwInt(32)):-1;
		out3[3]<==currentStateCount.getCount().cast(hwInt(32));
		
		
		io.output("out3",out3,array_type1);
		
// partikel 4 =========================================================

        	HWVar newState4=c1.getCount().cast(hwInt(32))+mbState[3];

			HWVar change4 = constant.var(hwInt(32), -1);
			for(int u=0;u<8;u++)
			{

				change4 = newState4.eq(mbState[u])?u:change4;
			}
			change4 = (change4>-1)&(newState4.eq(mbState[3]))?-1:change4;

			HWVar BO_4 = (change4<0)&(newState4<(1+maxState[3])) ;
			
		HWVar p1_4=(newState4<mbState[0])?newState4:mbState[0];
		HWVar p2_4=(newState4<mbState[1])?((newState4<mbState[0])?mbState[0]:newState4):mbState[1];
		HWVar p3_4=(newState4<mbState[2])?((newState4<mbState[1])?mbState[1]:newState4):mbState[2];
		HWVar p4_4=(newState4<mbState[4])?((newState4<mbState[2])?mbState[2]:newState4):mbState[4];
		HWVar p5_4=(newState4<mbState[5])?((newState4<mbState[4])?mbState[4]:newState4):mbState[5];
		HWVar p6_4=(newState4<mbState[6])?((newState4<mbState[5])?mbState[5]:newState4):mbState[6];
		HWVar p7_4=(newState4<mbState[7])?((newState4<mbState[6])?mbState[6]:newState4):mbState[7];
		HWVar p8_4=(newState4>mbState[7])?newState4:mbState[7];

		HWVar key0_4=Bitops.concat(p1_4,p2_4,p3_4,p4_4,p5_4,p6_4,p7_4,p8_4);

		HWVar key1_4=key0_4^(key0_4>>a);

		HWVar key2_4=key1_4^(key1_4<<b);

		HWVar key3_4=key2_4^(key2_4>>c);

		HWVar key_4=key2_4.slice(0,32);

		HWVar addr4=key3_4.slice(0,32)^(key3_4.slice(32,32)^(key3_4.slice(64,32)^(key3_4.slice(96,32)^(key3_4.slice(128,32)^(key3_4.slice(160,32)^(key3_4.slice(192,32)^(key3_4.slice(224,32))))))));
			
		HWVar sign_4=(newState4.eq(p1_4))?constant.var(hwInt(32),0):((newState4.eq(p2_4))?constant.var(hwInt(32),1):((newState4.eq(p3_4))?constant.var(hwInt(32),2):((newState4.eq(p4_4))?constant.var(hwInt(32),3):((newState4.eq(p5_4))?constant.var(hwInt(32),4):((newState4.eq(p6_4))?constant.var(hwInt(32),5):((newState4.eq(p7_4))?constant.var(hwInt(32),6):constant.var(hwInt(32),7)))))));
		
		sign_4 = sign_4 +1;

		out4[0]<==BO_4?addr4.cast(hwInt(32)):-1;
		out4[1]<==BO_4?sign_4:-1;
		out4[2]<==BO_4?key_4.cast(hwInt(32)):-1;
		out4[3]<==currentStateCount.getCount().cast(hwInt(32));
		
		
		io.output("out4",out4,array_type1);
		
// partikel 5 =========================================================

        	HWVar newState5=c1.getCount().cast(hwInt(32))+mbState[4];

			HWVar change5 = constant.var(hwInt(32), -1);
			for(int u=0;u<8;u++)
			{

				change5 = newState5.eq(mbState[u])?u:change5;
			}
			change5 = (change5>-1)&(newState5.eq(mbState[4]))?-1:change5;

			HWVar BO_5 = (change5<0)&(newState5<(1+maxState[4])) ;
			
		HWVar p1_5=(newState5<mbState[0])?newState5:mbState[0];
		HWVar p2_5=(newState5<mbState[1])?((newState5<mbState[0])?mbState[0]:newState5):mbState[1];
		HWVar p3_5=(newState5<mbState[2])?((newState5<mbState[1])?mbState[1]:newState5):mbState[2];
		HWVar p4_5=(newState5<mbState[3])?((newState5<mbState[2])?mbState[2]:newState5):mbState[3];
		HWVar p5_5=(newState5<mbState[5])?((newState5<mbState[3])?mbState[3]:newState5):mbState[5];
		HWVar p6_5=(newState5<mbState[6])?((newState5<mbState[5])?mbState[5]:newState5):mbState[6];
		HWVar p7_5=(newState5<mbState[7])?((newState5<mbState[6])?mbState[6]:newState5):mbState[7];
		HWVar p8_5=(newState5>mbState[7])?newState5:mbState[7];

		HWVar key0_5=Bitops.concat(p1_5,p2_5,p3_5,p4_5,p5_5,p6_5,p7_5,p8_5);

		HWVar key1_5=key0_5^(key0_5>>a);

		HWVar key2_5=key1_5^(key1_5<<b);

		HWVar key3_5=key2_5^(key2_5>>c);

		HWVar key_5=key2_5.slice(0,32);

		HWVar addr5=key3_5.slice(0,32)^(key3_5.slice(32,32)^(key3_5.slice(64,32)^(key3_5.slice(96,32)^(key3_5.slice(128,32)^(key3_5.slice(160,32)^(key3_5.slice(192,32)^(key3_5.slice(224,32))))))));
		
		HWVar sign_5=(newState5.eq(p1_5))?constant.var(hwInt(32),0):((newState5.eq(p2_5))?constant.var(hwInt(32),1):((newState5.eq(p3_5))?constant.var(hwInt(32),2):((newState5.eq(p4_5))?constant.var(hwInt(32),3):((newState5.eq(p5_5))?constant.var(hwInt(32),4):((newState5.eq(p6_5))?constant.var(hwInt(32),5):((newState5.eq(p7_5))?constant.var(hwInt(32),6):constant.var(hwInt(32),7)))))));
		


		out5[0]<==BO_5?addr5.cast(hwInt(32)):-1;
		out5[1]<==BO_5?sign_5:-1;
		out5[2]<==BO_5?key_5.cast(hwInt(32)):-1;
		out5[3]<==currentStateCount.getCount().cast(hwInt(32));
		
		
		io.output("out5",out5,array_type1);
		
// partikel 6 =========================================================

        	HWVar newState6=c1.getCount().cast(hwInt(32))+mbState[5];

			HWVar change6 = constant.var(hwInt(32), -1);
			for(int u=0;u<8;u++)
			{

				change6 = newState6.eq(mbState[u])?u:change6;
			}
			change6 = (change6>-1)&(newState6.eq(mbState[5]))?-1:change6;

			HWVar BO_6 = (change6<0)&(newState6<(1+maxState[5])) ;
			
		HWVar p1_6=(newState6<mbState[0])?newState6:mbState[0];
		HWVar p2_6=(newState6<mbState[1])?((newState6<mbState[0])?mbState[0]:newState6):mbState[1];
		HWVar p3_6=(newState6<mbState[2])?((newState6<mbState[1])?mbState[1]:newState6):mbState[2];
		HWVar p4_6=(newState6<mbState[3])?((newState6<mbState[2])?mbState[2]:newState6):mbState[3];
		HWVar p5_6=(newState6<mbState[4])?((newState6<mbState[3])?mbState[3]:newState6):mbState[4];
		HWVar p6_6=(newState6<mbState[6])?((newState6<mbState[4])?mbState[4]:newState6):mbState[6];
		HWVar p7_6=(newState6<mbState[7])?((newState6<mbState[6])?mbState[6]:newState6):mbState[7];
		HWVar p8_6=(newState6>mbState[7])?newState6:mbState[7];

		HWVar key0_6=Bitops.concat(p1_6,p2_6,p3_6,p4_6,p5_6,p6_6,p7_6,p8_6);

		HWVar key1_6=key0_6^(key0_6>>a);

		HWVar key2_6=key1_6^(key1_6<<b);

		HWVar key3_6=key2_6^(key2_6>>c);

		HWVar key_6=key2_6.slice(0,32);

		HWVar addr6=key3_6.slice(0,32)^(key3_6.slice(32,32)^(key3_6.slice(64,32)^(key3_6.slice(96,32)^(key3_6.slice(128,32)^(key3_6.slice(160,32)^(key3_6.slice(192,32)^(key3_6.slice(224,32))))))));
		
		HWVar sign_6=(newState6.eq(p1_6))?constant.var(hwInt(32),0):((newState6.eq(p2_6))?constant.var(hwInt(32),1):((newState6.eq(p3_6))?constant.var(hwInt(32),2):((newState6.eq(p4_6))?constant.var(hwInt(32),3):((newState6.eq(p5_6))?constant.var(hwInt(32),4):((newState6.eq(p6_6))?constant.var(hwInt(32),5):((newState6.eq(p7_6))?constant.var(hwInt(32),6):constant.var(hwInt(32),7)))))));
		
		sign_6 = sign_6 +1;


		out6[0]<==BO_6?addr6.cast(hwInt(32)):-1;
		out6[1]<==BO_6?sign_6:-1;
		out6[2]<==BO_6?key_6.cast(hwInt(32)):-1;
		out6[3]<==currentStateCount.getCount().cast(hwInt(32));
		
		
		io.output("out6",out6,array_type1);
		
		
// partikel 7 =========================================================

        	HWVar newState7=c1.getCount().cast(hwInt(32))+mbState[6];

			HWVar change7 = constant.var(hwInt(32), -1);
			for(int u=0;u<8;u++)
			{

				change7 = newState7.eq(mbState[u])?u:change7;
			}
			change7 = (change7>-1)&(newState7.eq(mbState[6]))?-1:change7;

			HWVar BO_7 = (change7<0)&(newState7<(1+maxState[6])) ;
			
		HWVar p1_7=(newState7<mbState[0])?newState7:mbState[0];
		HWVar p2_7=(newState7<mbState[1])?((newState7<mbState[0])?mbState[0]:newState7):mbState[1];
		HWVar p3_7=(newState7<mbState[2])?((newState7<mbState[1])?mbState[1]:newState7):mbState[2];
		HWVar p4_7=(newState7<mbState[3])?((newState7<mbState[2])?mbState[2]:newState7):mbState[3];
		HWVar p5_7=(newState7<mbState[4])?((newState7<mbState[3])?mbState[3]:newState7):mbState[4];
		HWVar p6_7=(newState7<mbState[5])?((newState7<mbState[4])?mbState[4]:newState7):mbState[5];
		HWVar p7_7=(newState7<mbState[7])?((newState7<mbState[5])?mbState[5]:newState7):mbState[7];
		HWVar p8_7=(newState7>mbState[7])?newState7:mbState[7];

		HWVar key0_7=Bitops.concat(p1_7,p2_7,p3_7,p4_7,p5_7,p6_7,p7_7,p8_7);

		HWVar key1_7=key0_7^(key0_7>>a);

		HWVar key2_7=key1_7^(key1_7<<b);

		HWVar key3_7=key2_7^(key2_7>>c);

		HWVar key_7=key2_7.slice(0,32);

		HWVar addr7=key3_7.slice(0,32)^(key3_7.slice(32,32)^(key3_7.slice(64,32)^(key3_7.slice(96,32)^(key3_7.slice(128,32)^(key3_7.slice(160,32)^(key3_7.slice(192,32)^(key3_7.slice(224,32))))))));
		
		HWVar sign_7=(newState7.eq(p1_7))?constant.var(hwInt(32),0):((newState7.eq(p2_7))?constant.var(hwInt(32),1):((newState7.eq(p3_7))?constant.var(hwInt(32),2):((newState7.eq(p4_7))?constant.var(hwInt(32),3):((newState7.eq(p5_7))?constant.var(hwInt(32),4):((newState7.eq(p6_7))?constant.var(hwInt(32),5):((newState7.eq(p7_7))?constant.var(hwInt(32),6):constant.var(hwInt(32),7)))))));



		out7[0]<==BO_7?addr7.cast(hwInt(32)):-1;
		out7[1]<==BO_7?sign_7:-1;
		out7[2]<==BO_7?key_7.cast(hwInt(32)):-1;
		out7[3]<==currentStateCount.getCount().cast(hwInt(32));
		
		
		io.output("out7",out7,array_type1);
		
// partikel 8 =========================================================

        	HWVar newState8=c1.getCount().cast(hwInt(32))+mbState[7];

			HWVar change8 = constant.var(hwInt(32), -1);
			for(int u=0;u<8;u++)
			{

				change8 = newState8.eq(mbState[u])?u:change8;
			}
			change8 = (change8>-1)&(newState8.eq(mbState[7]))?-1:change8;

			HWVar BO_8 = (change8<0)&(newState8<(1+maxState[7])) ;
			
		
		HWVar p1_8=(newState8<mbState[0])?newState8:mbState[0];
		HWVar p2_8=(newState8<mbState[1])?((newState8<mbState[0])?mbState[0]:newState8):mbState[1];
		HWVar p3_8=(newState8<mbState[2])?((newState8<mbState[1])?mbState[1]:newState8):mbState[2];
		HWVar p4_8=(newState8<mbState[3])?((newState8<mbState[2])?mbState[2]:newState8):mbState[3];
		HWVar p5_8=(newState8<mbState[4])?((newState8<mbState[3])?mbState[3]:newState8):mbState[4];
		HWVar p6_8=(newState8<mbState[5])?((newState8<mbState[4])?mbState[4]:newState8):mbState[5];
		HWVar p7_8=(newState8<mbState[6])?((newState8<mbState[5])?mbState[5]:newState8):mbState[6];
		HWVar p8_8=(newState8>mbState[6])?newState8:mbState[6];

		HWVar key0_8=Bitops.concat(p1_8,p2_8,p3_8,p4_8,p5_8,p6_8,p7_8,p8_8);

		HWVar key1_8=key0_8^(key0_8>>a);

		HWVar key2_8=key1_8^(key1_8<<b);

		HWVar key3_8=key2_8^(key2_8>>c);

		HWVar key_8=key2_8.slice(0,32);

		HWVar addr8=key3_8.slice(0,32)^(key3_8.slice(32,32)^(key3_8.slice(64,32)^(key3_8.slice(96,32)^(key3_8.slice(128,32)^(key3_8.slice(160,32)^(key3_8.slice(192,32)^(key3_8.slice(224,32))))))));
		
		HWVar sign_8=(newState8.eq(p1_8))?constant.var(hwInt(32),0):((newState8.eq(p2_8))?constant.var(hwInt(32),1):((newState8.eq(p3_8))?constant.var(hwInt(32),2):((newState8.eq(p4_8))?constant.var(hwInt(32),3):((newState8.eq(p5_8))?constant.var(hwInt(32),4):((newState8.eq(p6_8))?constant.var(hwInt(32),5):((newState8.eq(p7_8))?constant.var(hwInt(32),6):constant.var(hwInt(32),7)))))));
		
		sign_8 = sign_8 +1;


		out8[0]<==BO_8?addr8.cast(hwInt(32)):-1;
		out8[1]<==BO_8?sign_8:-1;
		out8[2]<==BO_8?key_8.cast(hwInt(32)):-1;
		out8[3]<==currentStateCount.getCount().cast(hwInt(32));
		
		
		io.output("out8",out8,array_type1);		
		
		
		
		
		
		

	}

}